package com.zhentao.controller;

import com.zhentao.dto.GoodsDto;
import com.zhentao.dto.OrderAddDto;
import com.zhentao.dto.VerifyDto;
import com.zhentao.service.GoodsService;
import com.zhentao.utils.OrderNoUtil;
import com.zhentao.utils.VerifyUtil;
import com.zhentao.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @date: 2025/5/16 9:52
 * @author: ftt
 */
@RestController
public class GoodsController {

    @Autowired
    private GoodsService goodsService;

    @PostMapping("/goodsAdd")
    public ResultVo goodsAdd(@RequestBody GoodsDto goodsDto){
        goodsService.goodsAdd(goodsDto);
        return ResultVo.OK("添加成功", null);
    }

    @PostMapping("OrderSign")
    public ResultVo OrderSign(@RequestBody OrderAddDto goodsDto, @RequestHeader("appId") String appId, @RequestHeader("reqId") String reqId){
        VerifyDto verifyDto = new VerifyDto();
        verifyDto.setSign(goodsDto.getSign());
        verifyDto.setAppId(appId);
        verifyDto.setReqId(reqId);
        verifyDto.setReqTime(goodsDto.getReqTime());
        verifyDto.setAppSecret("123");

        Boolean verify = VerifyUtil.verify(verifyDto);
        if(!verify){
            return ResultVo.ERROR(1002, "签名验证失败");
        }
        List list = new ArrayList();
        list.add("红富士苹果");
        return ResultVo.OK("签名验证成功", list);
    }

    @GetMapping("/OrderNo")
    public String OrderNo(){
        return OrderNoUtil.generateOrderNo();
    }
}
